"use strict";
/**
 * @copyright   2017, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var rimraf_1 = __importDefault(require("rimraf"));
var core_1 = require("@beemo/core");
// Success: Writes file list to stdout
// Failure: Throws SyntaxError to stderr
var BabelDriver = /** @class */ (function (_super) {
    __extends(BabelDriver, _super);
    function BabelDriver() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Automatically clean the target folder if --out-dir is used.
         */
        _this.handleCleanTarget = function (driver, argv, _a) {
            var args = _a.args;
            if (args.clean && args.outDir) {
                rimraf_1.default.sync(path_1.default.resolve(args.outDir));
            }
        };
        return _this;
    }
    BabelDriver.prototype.bootstrap = function () {
        this.setMetadata({
            bin: 'babel',
            configName: 'babel.config.js',
            description: 'Transpile files with Babel',
            title: 'Babel',
        });
        this.setCommandOptions({
            clean: {
                boolean: true,
                default: true,
                description: 'Clean the target folder',
            },
        });
        this.on('babel.before-execute', this.handleCleanTarget);
    };
    return BabelDriver;
}(core_1.Driver));
exports.default = BabelDriver;
